Magellan Linux

Diff of /trunk/installer-simple/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 2343 by niro, Fri Jan 3 14:58:22 2014 UTC revision 2411 by niro, Tue Jan 7 13:31:50 2014 UTC
# Line 16  INSTALLER_LIBDIR="%LIBDIR%" Line 16  INSTALLER_LIBDIR="%LIBDIR%"
16  # -> now in images.conf  # -> now in images.conf
17  CURRENTLINE=0  CURRENTLINE=0
18    
19  # configuration  die()
20  if [ -e %SYSCONFDIR%/installer.conf ]  {
21  then   echo "Error: $@"
22   source %SYSCONFDIR%/installer.conf   exit 1
23  else  }
24   die "/etc/installer.conf not found"  
25  fi  # load common includes
26    for inc in %SYSCONFDIR%/installer.conf \
27     ${INSTALLER_LIBDIR}/functions/common.sh \
28     ${INSTALLER_LIBDIR}/functions/common-dialogs.sh \
29     ${INSTALLER_LIBDIR}/functions/hwdetection.sh \
30     ${INSTALLER_LIBDIR}/functions/installer-dialogs.sh
31    do
32     if [ -e ${inc} ]
33     then
34     source "${inc}"
35     else
36     die "'${inc}' not found"
37     fi
38    done
39    
40  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
41  # -> now in images.conf  # -> now in images.conf
# Line 39  else Line 52  else
52   die "/mnt/cdrom/system/images.conf not found"   die "/mnt/cdrom/system/images.conf not found"
53  fi  fi
54    
 # includes  
 source ${INSTALLER_LIBDIR}/functions/hwdetection.sh  
   
55  ### System/Config Version  ### System/Config Version
56  VERSION="%VERSIONTAG%"  VERSION="%VERSIONTAG%"
57  TITLE="${DEFAULT_TITLE} - ${VERSION}"  TITLE="${DEFAULT_TITLE} - ${VERSION}"
58    
59    # some sane defaults
60  CDROOT="${DEFAULT_CDROOT}"  CDROOT="${DEFAULT_CDROOT}"
61  INSTALLROOT="${DEFAULT_INSTALLROOT}"  INSTALLROOT="${DEFAULT_INSTALLROOT}"
62    KERNELPKG="${DEFAULT_KERNELPKG}"
63  # standard kernel opts  KERNELOPTS="${DEFAULT_KERNELOPTS}"
 KERNELOPTS="quiet video=1024x768"  
   
 # grub options  
64  GRUBLEGACYOPTS=""  GRUBLEGACYOPTS=""
65  GRUB2OPTS=""  GRUB2OPTS=""
   
 # fdisk options  
66  FDISKPARTIONBELOW256MB=0  FDISKPARTIONBELOW256MB=0
   
 # default specialdevices  
67  SPECIALDEVICE=""  SPECIALDEVICE=""
68  FORMFACTOR="desktop"  FORMFACTOR="${DEFAULT_FORMFACTOR}"
   
 # target filesystem  
69  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
70    
71  #################################################  #################################################
72  #  DIALOG BOXEN #  #  DIALOG BOXEN #
73  #################################################  #################################################
74    
75  die()  trap_exit()
76  {  {
77   echo "Error: $@"   is_mounted --location "${INSTALLROOT}/dev" && umount ${INSTALLROOT}/dev
78     is_mounted --location "${INSTALLROOT}/proc" && umount ${INSTALLROOT}/proc
79     is_mounted --location "${INSTALLROOT}/sys" && umount ${INSTALLROOT}/sys
80     is_mounted --location "${INSTALLROOT}/boot" && umount ${INSTALLROOT}/boot
81     is_mounted --location "${INSTALLROOT}" && umount ${INSTALLROOT}
82    
83     echo $"Installation aborted."
84   exit 1   exit 1
85  }  }
86    
# Line 86  dialog_die() Line 94  dialog_die()
94    
95  dialog_warning()  dialog_warning()
96  {  {
97   dialog \   local retval
98   --backtitle "${TITLE}" \  
99   --colors \   yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
100   --defaultno \   retval=$?
101   --yesno "\Z1 !!! Achtung !!! \Zn\n\n\   if [[ ${retval} -eq 1 ]]
  Diese Festplatte wird unwiederruflich geloescht werden.\n\n\  
  Soll ich wirklich fortfahren ?" 10 70  
  RES=$?  
  if [[ ${RES} -eq 1 ]]  
102   then   then
103   clear   clear
104   echo "Der Vorgang wurde abgebrochen."   echo $"The process was aborted."
105   exit 1   exit 1
106   fi   fi
107  }  }
108    
109  dialog_setup_hdd_info()  dialog_setup_hdd_info()
110  {  {
111   local SHDD="$(echo ${HDD} | sed 's/\/dev\///')"   local SHDD="${HDD//\/dev\/}"
   
  dialog \  
  --colors \  
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 3 Partitionen an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit ca. 50MB\n\  
  [ \Z3${SHDD}2\Zn ] Typ: \Z3Linux Swap\Zn mit ca. 256MB\n\  
  [ \Z3${SHDD}3\Zn ] Typ: \Z3Linux \Zn mit dem Rest (min. 256MB)\n\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
 }  
   
 dialog_setup_hdd_info_flash()  
 {  
  local SHDD="$(echo $HDD | sed 's/\/dev\///')"  
112    
113   dialog \   messagebox -h $"[ Harddrive partitioning ]" \
114   --colors \   $"\nPlease create 1 partition.\n\n\[ \Z3${SHDD}1\Zn ] type: \Z3linux\Zn with the whole diskspace\n\Please mark ${SHDD}1 \Z3bootable\Zn."
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 1 Partition an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit dem gesamten Speicher\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
115  }  }
116    
117  dialog_setup_hdd_info_auto()  dialog_setup_hdd_info_auto()
118  {  {
119   local SHDD="$(echo $HDD | sed 's/\/dev\///')"   local SHDD="${HDD//\/dev\/}"
120    
121   dialog \   messagebox -h $"[ Harddrive partitioning ]" \
122   --colors \   $"\Z1Warning!\Zn\n\nAll data on disk [ \Z3${HDD}\Zn ] will be erased!"
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nAchtung!\n\  
  Alle Daten werden von der Disk [ \Z3${HDD}\Zn ] gelöscht!" 12 81  
123  }  }
124    
125  dialog_setup_system_menu()  dialog_setup_system_menu()
# Line 161  dialog_setup_system_menu() Line 138  dialog_setup_system_menu()
138   "" "" \   "" "" \
139   "" "\Z1Experten Modi:\Zn" \   "" "\Z1Experten Modi:\Zn" \
140   "2" "Normale IDE-Disk (Manuell)" \   "2" "Normale IDE-Disk (Manuell)" \
  "3" "Flash-Speicher (Manuell)")  
141   RES=$?   RES=$?
142   [[ ${RES} -eq 1 ]] && return 1   [[ ${RES} -eq 1 ]] && return 1
143   if [[ ${RES} -eq 0 ]]   if [[ ${RES} -eq 0 ]]
# Line 169  dialog_setup_system_menu() Line 145  dialog_setup_system_menu()
145   case "${i}" in   case "${i}" in
146   "1") run_install_auto ;;   "1") run_install_auto ;;
147   "2") run_install_normal ;;   "2") run_install_normal ;;
  "3") run_install_flash ;;  
148   "") dialog_setup_system_menu;;   "") dialog_setup_system_menu;;
149   esac   esac
150   fi   fi
# Line 180  dialog_hardware_detection() Line 155  dialog_hardware_detection()
155   local i   local i
156   local hwtmp   local hwtmp
157    
158   if [ -x $(which mktemp &> /dev/null) ]   if [ -x $(type -P mktemp) ]
159   then   then
160   hwtmp="$(mktemp)"   hwtmp="$(mktemp)"
161   else   else
162   hwtmp="/tmp/hwtmp.sh"   hwtmp="/tmp/hwtmp.sh"
163   fi   fi
164    
165   [[ ! -z ${installdevs} ]] && installdevs=""   run_hardware_detection_disks
166    
167   echo "dialog \\"  > ${hwtmp}   echo "dialog \\"  > ${hwtmp}
168   echo "--backtitle \"${TITLE}\" \\" >> ${hwtmp}   echo "--backtitle \"${TITLE}\" \\" >> ${hwtmp}
# Line 197  dialog_hardware_detection() Line 172  dialog_hardware_detection()
172   echo "--msgbox \"Gefundene Hardware:\n\n \\" >> ${hwtmp}   echo "--msgbox \"Gefundene Hardware:\n\n \\" >> ${hwtmp}
173   echo " Festplatten:\n \\" >> ${hwtmp}   echo " Festplatten:\n \\" >> ${hwtmp}
174    
175   if [[ ! -z ${scsidisks} ]]   if [[ ! -z ${ALL_DISKS} ]]
176   then   then
177   for i in ${scsidisks}   for i in ${ALL_DISKS}
178   do   do
179   if [[ ${i} != ${cdromdev} ]]   echo " \\Z3${i}\\Zn\n \\" >> ${hwtmp}
  then  
  echo " \\Z7SCSI: \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  installdevs="${installdevs} ${i}"  
  fi  
180   done   done
181   fi   fi
182    
183   if [[ ! -z ${idedisks} ]]   if [[ ! -z ${ALL_CDROMS} ]]
184   then   then
185   for i in ${idedisks}   echo " \n \\" >> ${hwtmp}
186     echo " CDROM Laufwerke:\n \\" >> ${hwtmp}
187     for i in ${ALL_CDROMS}
188   do   do
189   if [[ ${i} != ${cdromdev} ]]   echo " \\Z3${i}\\Zn\n \\" >> ${hwtmp}
  then  
  echo " \\Z7IDE:  \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  installdevs="${installdevs} ${i}"  
  fi  
190   done   done
191   fi   fi
192    
  if [[ ! -z ${cdromdev} ]]  
  then  
  echo " \n \\" >> ${hwtmp}  
  echo " \\Z7andere Laufwerke:\n \\" >> ${hwtmp}  
  echo " CDROM: \\Z3${cdromdev}\\Zn\n \\" >> ${hwtmp}  
  fi  
   
193   # other devices   # other devices
194   run_hardware_detection   run_hardware_detection
195   case "${SPECIALDEVICE}" in   case "${SPECIALDEVICE}" in
# Line 290  dialog_setup_hdd_partitions_manuell() Line 252  dialog_setup_hdd_partitions_manuell()
252   fi   fi
253  }  }
254    
255  dialog_setup_hdd_partitions_manuell_flash()  dialog_setup_hdd_partitions_auto()
256  {  {
257   local i   local i
258    
# Line 322  dialog_setup_hdd_partitions_manuell_flas Line 284  dialog_setup_hdd_partitions_manuell_flas
284   [[ ${RES} -eq 1 ]] && return 1   [[ ${RES} -eq 1 ]] && return 1
285   if [[ ${RES} -eq 0 ]]   if [[ ${RES} -eq 0 ]]
286   then   then
287   dialog_setup_hdd_info_flash   dialog_setup_hdd_info_auto
288   setup_hdd_partitions_manuell_flash   dialog_setup_hdd_create_partitions
289     setup_hdd_partitions_auto
290   fi   fi
291   fi   fi
292  }  }
293    
294  dialog_setup_hdd_partitions_auto()  run_hardware_detection_disks()
295  {  {
296   local i   local bootdev
297    
298   if [[ -z ${installdevs} ]]   # all disks but exclude ramdisks
299     export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
300     # remove the boot device from ALL_DISKS if it was an usbstick
301     if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
302   then   then
303   dialog \   bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"
304   --backtitle "${TITLE}" \   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
  exit 1  
  else  
   
  echo "dialog \\" > /tmp/hddtmp.sh  
  echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh  
  echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh  
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_auto  
  dialog_setup_hdd_create_partitions  
  setup_hdd_partitions_auto  
  fi  
305   fi   fi
306     export ALL_CDROMS="$(get_hwinfo cdrom)"
307  }  }
308    
309  dialog_setup_hdd_create_partitions()  dialog_setup_hdd_create_partitions()
# Line 606  EOF Line 545  EOF
545    
546  setup_hdd_partitions_manuell()  setup_hdd_partitions_manuell()
547  {  {
  BOOTHDD="${HDD}1"  
  SWAPHDD="${HDD}2"  
  ROOTHDD="${HDD}3"  
   
  ## hdds partitionieren manuell  
  cfdisk ${HDD} || dialog_die  
 }  
   
 setup_hdd_partitions_manuell_flash()  
 {  
548   ROOTHDD="${HDD}1"   ROOTHDD="${HDD}1"
549    
550   ## hdds partitionieren manuell   ## hdds partitionieren manuell
# Line 624  setup_hdd_partitions_manuell_flash() Line 553  setup_hdd_partitions_manuell_flash()
553    
554  setup_hdd_format()  setup_hdd_format()
555  {  {
  mkswap ${SWAPHDD} || dialog_die  
  mke2fs -j -q ${BOOTHDD} || dialog_die  
  mke2fs -j -q ${ROOTHDD} || dialog_die  
 }  
   
 setup_hdd_format_flash()  
 {  
556   mke2fs -j -q ${ROOTHDD} || dialog_die   mke2fs -j -q ${ROOTHDD} || dialog_die
557  }  }
558    
559  install_mount_rootfs()  install_mount_rootfs()
560  {  {
  swapon ${SWAPHDD} || dialog_die  
  mount ${ROOTHDD} ${INSTALLROOT} || dialog_die  
  install -d ${INSTALLROOT}/boot || dialog_die  
  mount ${BOOTHDD} ${INSTALLROOT}/boot || dialog_die  
  cd ${INSTALLROOT} || dialog_die  
 }  
   
 install_mount_rootfs_flash()  
 {  
561   mount ${ROOTHDD} ${INSTALLROOT} || dialog_die   mount ${ROOTHDD} ${INSTALLROOT} || dialog_die
562   install -d ${INSTALLROOT}/boot || dialog_die   install -d ${INSTALLROOT}/boot || dialog_die
563   cd ${INSTALLROOT} || dialog_die   cd ${INSTALLROOT} || dialog_die
# Line 829  CHROOTEOF Line 742  CHROOTEOF
742    
743  is_uuid_supported()  is_uuid_supported()
744  {  {
745   if [[ -x $(which busybox.mkinitrd &> /dev/null) ]]   if [[ -x $(type -P busybox.mkinitrd) ]]
746   then   then
747   # only detect uuids if supported   # only detect uuids if supported
748   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]
# Line 865  install_system_settings() Line 778  install_system_settings()
778   # schreibe fstab   # schreibe fstab
779   if is_uuid_supported   if is_uuid_supported
780   then   then
  echo -e "UUID=$(get_uuid ${BOOTHDD})\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLROOT}/etc/fstab || dialog_die  
781   echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die   echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
782   else   else
  echo -e "${BOOTHDD}\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLROOT}/etc/fstab || dialog_die  
783   echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die   echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
784   fi   fi
785   # not needed busybox loads all with swapon -a, even if not mentioned in fstab   # not needed busybox loads all with swapon -a, even if not mentioned in fstab
# Line 893  install_system_settings() Line 804  install_system_settings()
804   fi   fi
805  }  }
806    
 install_system_settings_flash()  
 {  
  # schreibe fstab  
  if is_uuid_supported  
  then  
  echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLROOT}/etc/fstab || dialog_die  
  else  
  echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLROOT}/etc/fstab || dialog_die  
  fi  
  echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
  echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
 }  
   
807  install_umount_rootfs()  install_umount_rootfs()
808  {  {
809   cd /   cd /
810   umount ${INSTALLROOT}/boot || dialog_die   umount ${INSTALLROOT}/boot || dialog_die
811   umount ${INSTALLROOT} || dialog_die   umount ${INSTALLROOT} || dialog_die
  swapoff ${SWAPHDD} || dialog_die  
 }  
   
 install_umount_rootfs_flash()  
 {  
  cd /  
  umount ${INSTALLROOT} || dialog_die  
812  }  }
813    
814  install_do_reboot()  install_do_reboot()
# Line 951  run_install_normal() Line 842  run_install_normal()
842   dialog_install_successful   dialog_install_successful
843  }  }
844    
 run_install_flash()  
 {  
  dialog_hardware_detection  
   
  dialog_setup_hdd_partitions_manuell_flash  
  dialog_setup_hdd_format  
  setup_hdd_format_flash > /dev/null  
  install_mount_rootfs_flash  
  (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image  
   
  dialog_install_settings  
  sleep 1  
  install_system_settings_flash  
  install_initrd_chroot  
   
  dialog_install_bootsector  
  install_bootsector_chroot  
   
  install_umount_rootfs_flash  
  dialog_install_successful  
 }  
   
845  run_install_auto()  run_install_auto()
846  {  {
847   dialog_hardware_detection   dialog_hardware_detection
848    
849   dialog_setup_hdd_partitions_auto   dialog_setup_hdd_partitions_auto
850   dialog_setup_hdd_format   dialog_setup_hdd_format
851   setup_hdd_format_flash > /dev/null   setup_hdd_format > /dev/null
852   install_mount_rootfs_flash   install_mount_rootfs
853   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image
854    
855   dialog_install_settings   dialog_install_settings
856   sleep 1   sleep 1
857   install_system_settings_flash   install_system_settings
858   install_initrd_chroot   install_initrd_chroot
859    
860   dialog_install_bootsector   dialog_install_bootsector
861   install_bootsector_chroot   install_bootsector_chroot
862    
863   install_umount_rootfs_flash   install_umount_rootfs
864   dialog_install_successful   dialog_install_successful
865  }  }
866    
867    # set some proper traps
868    trap "trap_exit" SIGINT SIGQUIT
869    
870  dialog_main  dialog_main
871    
872  exit 0  exit 0

Legend:
Removed from v.2343  
changed lines
  Added in v.2411